# CareMyWay Client

Generated using [create-react-app](https://github.com/facebookincubator/create-react-app).

## Quickstart (Development)

* Ensure the server is up and running locally.
  * [CareMyWay](https://gogs.tannercollin.com/tanner/caremyway)
* Install dependencies with `yarn install`
* Run the client with `yarn start`

Now you can visit `localhost:3000` from your browser.

## Environment Variables

The environment variables are embedded during the build time. For more information, please refer to the [docs](https://github.com/facebookincubator/create-react-app/blob/master/packages/react-scripts/template/README.md#adding-custom-environment-variables).

| Environment Variable      | Default Value             | Description                     |
| ------------------------- |:-------------------------:| -------------------------------:|
| `REACT_APP_API_ENDPOINT`  | `"http://localhost:8000"` | Server API endpoint             |
| `REACT_APP_REDUX_LOGGING` | ` `                       | Set any value for Redux logging |


## Production

To build the production instance of this application, run the following:

```bash
export REACT_APP_API_ENDPOINT="http://dev.tannercollin.com:8000/" && yarn build

# then, to serve the production site locally
yarn global add serve
serve -s build --port 3000
```

## Testing

To test the react app, call `yarn test`.
