import {
  IS_SENDING_AUTH_REQUEST,
  SET_AUTH_REQUEST_ERROR,
  CLEAR_AUTH_REQUEST_ERROR,
  SET_AUTH_REQUEST_SUCCESS,
  CLEAR_AUTH_REQUEST_SUCCESS,
  SET_SELF_USER_TOKEN,
  SET_FORM_EMAIL,
  SET_FORM_PASSWORD,
  SET_FORM_PASSWORD_CONFIRMATION,
  SET_FORM_EMAIL_VERIFICATION,
  SET_FORM_OLD_PASSWORD,
  SET_CLEAR_AUTH_STATE
} from "../../constants/auth.constants";
import { parseError } from "../common.actions";

export function isSendingAuthRequest(sendingRequest) {
  return {
    type: IS_SENDING_AUTH_REQUEST,
    data: sendingRequest
  };
}

export function setAuthRequestError(exception) {
  let error = parseError(exception);
  if (error.email) {
    error["Email"] = error.email;
    delete error["email"];
  }
  if (error.password) {
    error["Password"] = error.password;
    delete error["password"];
  }
  if (error.password1) {
    error["Password"] = error.password1;
    delete error["password1"];
  }
  if (error.password2) {
    error["Confirm Password"] = error.password2;
    delete error["password2"];
  }
  if (error.non_field_errors) {
    error["Non Field Errors"] = error.non_field_errors;
    delete error["non_field_errors"];
  }
  if (error.detail) {
    error["Detail"] = error.detail;
    delete error["detail"];
  }
  if (error.old_password) {
    error["Old Password"] = error.old_password;
    delete error["old_password"];
  }
  if (error.new_password1) {
    error["New Password"] = error.new_password1;
    delete error["new_password1"];
  }
  if (error.new_password2) {
    error["Confirm New Password"] = error.new_password2;
    delete error["new_password2"];
  }
  if (error.token) {
    error["Token"] = error.token;
    delete error["token"];
  }
  if (error.uid) {
    error["UID"] = error.uid;
    delete error["uid"];
  }
  if (error.key) {
    error["Email Verification Key"] = error.key;
    delete error["key"];
  }

  return {
    type: SET_AUTH_REQUEST_ERROR,
    data: error
  };
}

export function clearAuthRequestError() {
  return {
    type: CLEAR_AUTH_REQUEST_ERROR
  };
}

export function setAuthRequestSuccess(response) {
  return {
    type: SET_AUTH_REQUEST_SUCCESS,
    data: response.detail || response
  };
}

export function clearAuthRequestSuccess() {
  return {
    type: CLEAR_AUTH_REQUEST_SUCCESS
  };
}

export function setSelfUserToken(selfUser) {
  return {
    type: SET_SELF_USER_TOKEN,
    data: selfUser
  };
}

export function setFormEmail(email) {
  return {
    type: SET_FORM_EMAIL,
    data: email
  };
}

export function setFormPassword(password) {
  return {
    type: SET_FORM_PASSWORD,
    data: password
  };
}

export function setFormPasswordConfirmation(passwordConfirmation) {
  return {
    type: SET_FORM_PASSWORD_CONFIRMATION,
    data: passwordConfirmation
  };
}

export function setFormEmailVerification(emailKey) {
  return {
    type: SET_FORM_EMAIL_VERIFICATION,
    data: emailKey
  };
}

export function setFormOldPassword(oldPassword) {
  return {
    type: SET_FORM_OLD_PASSWORD,
    data: oldPassword
  };
}

export function setClearAuthState() {
  return {
    type: SET_CLEAR_AUTH_STATE
  };
}
