import {
  IS_SENDING_CSHIFT_REQUEST,
  SET_CSHIFT_REQUEST_ERRORS,
  CLEAR_CSHIFT_REQUEST_ERRORS,
  SET_CSHIFT_REQUEST_SUCCESS,
  CLEAR_CSHIFT_REQUEST_SUCCESS,
  SET_FORM_EMPLOYEE_UUID,
  SET_FORM_PRICE_UUID,
  SET_FORM_SHIFT_START_TIME,
  SET_FORM_SHIFT_DURATION,
  SET_FORM_SHIFT_NOTE,
  SET_FORM_SHIFT_DATES,
  SET_CSHIFT_UUID,
  SET_CSHIFT_PAGE,
  SET_CSHIFT_APPROVAL_FILTER,
  SET_CSHIFT_COMPLETED_FILTER,
  SET_CSHIFT_PROVIDER_FILTER,
  SET_CSHIFT_WORKTYPE_FILTER,
  SET_CLEAR_CSHIFT_STATE
} from "../../constants/cShift.constants";
import { parseError } from "../common.actions";

function transformError(error) {
  if (error.get_price_uuid) {
    error["Price"] = error.get_price_uuid;
    delete error["get_price_uuid"];
  }
}

export function isSendingCShiftRequest(sendingRequest) {
  return {
    type: IS_SENDING_CSHIFT_REQUEST,
    data: sendingRequest
  };
}

export function setCShiftRequestError(exception) {
  let error = parseError(exception);
  transformError(error);
  return {
    type: SET_CSHIFT_REQUEST_ERRORS,
    data: [error]
  };
}

export function setCShiftRequestErrors(exceptions) {
  let errors = exceptions.map(exception => parseError(exception));
  errors.forEach(error => transformError(error));
  return {
    type: SET_CSHIFT_REQUEST_ERRORS,
    data: errors
  };
}

export function clearCShiftRequestError() {
  return {
    type: CLEAR_CSHIFT_REQUEST_ERRORS
  };
}

export function setCShiftRequestSuccess(response) {
  return {
    type: SET_CSHIFT_REQUEST_SUCCESS,
    data: response.detail || response
  };
}

export function clearCShiftRequestSuccess() {
  return {
    type: CLEAR_CSHIFT_REQUEST_SUCCESS
  };
}

export function setFormEmployeeUUID(uuid) {
  return {
    type: SET_FORM_EMPLOYEE_UUID,
    data: uuid
  };
}

export function setFormPriceUUID(uuid) {
  return {
    type: SET_FORM_PRICE_UUID,
    data: uuid
  };
}

export function setFormShiftStartTime(startTime) {
  return {
    type: SET_FORM_SHIFT_START_TIME,
    data: startTime
  };
}

export function setFormShiftDuration(duration) {
  return {
    type: SET_FORM_SHIFT_DURATION,
    data: duration
  };
}

export function setFormShiftNote(note) {
  return {
    type: SET_FORM_SHIFT_NOTE,
    data: note
  };
}

export function setFormShiftDates(dates) {
  return {
    type: SET_FORM_SHIFT_DATES,
    data: dates
  };
}

export function setCShiftUUID(uuid) {
  return {
    type: SET_CSHIFT_UUID,
    data: uuid
  };
}

export function setCShiftPage(page) {
  return {
    type: SET_CSHIFT_PAGE,
    data: page
  };
}

export function setCShiftApprovalFilter(approvalFilter) {
  return {
    type: SET_CSHIFT_APPROVAL_FILTER,
    data: approvalFilter
  };
}

export function setCShiftCompletedFilter(completedFilter) {
  return {
    type: SET_CSHIFT_COMPLETED_FILTER,
    data: completedFilter
  };
}

export function setCShiftProviderFilter(providerFilter) {
  return {
    type: SET_CSHIFT_PROVIDER_FILTER,
    data: providerFilter
  };
}

export function setCShiftWorkTypeFilter(workTypeFilter) {
  return {
    type: SET_CSHIFT_WORKTYPE_FILTER,
    data: workTypeFilter
  };
}

export function setClearCShiftState() {
  return {
    type: SET_CLEAR_CSHIFT_STATE
  };
}
