import {
  CREATE_MULTIPLE_CSHIFT_REQUEST,
  GET_CSHIFTS_REQUEST,
  GET_CSHIFT_REQUEST,
  EDIT_CSHIFT_REQUEST,
  DELETE_CSHIFT_REQUEST
} from "../../constants/cShift.constants";

/**
 * Saga action for creating a list of shifts
 * @param postBody[] array of post body for cshift post endpoint
 */
export function createMultipleCShiftRequest(postBodies) {
  return {
    type: CREATE_MULTIPLE_CSHIFT_REQUEST,
    data: postBodies
  };
}

export function getCShiftsRequest(params) {
  return {
    type: GET_CSHIFTS_REQUEST,
    data: params
  };
}

export function getCShiftRequest(payload) {
  return {
    type: GET_CSHIFT_REQUEST,
    data: payload
  };
}

export function editCShiftRequest(payload) {
  return {
    type: EDIT_CSHIFT_REQUEST,
    data: payload
  }
}

export function deleteCShiftRequest(uuid) {
  return {
    type: DELETE_CSHIFT_REQUEST,
    data: uuid
  }
}