import {
  IS_SENDING_USER_REQUEST,
  SET_USER_REQUEST_ERROR,
  CLEAR_USER_REQUEST_ERROR,
  SET_USER_REQUEST_SUCCESS,
  CLEAR_USER_REQUEST_SUCCESS,
  SET_SELF_USER,
  SET_COMPLETE_REGISTRATION_STEP,
  SET_COMPLETE_REGISTRATION_CLIENT_OR_PROVIDER,
  SET_FORM_PHONE_NUMBER,
  SET_FORM_BUSINESS_NUMBER,
  SET_FORM_SOCIAL_INSURANCE_NUMBER,
  SET_EDIT_PROFILE_TAB_ACTIVE_INDEX,
  SET_CLEAR_USER_STATE
} from "../../constants/user.constants";
import { parseError } from "../common.actions";

export function isSendingUserRequest(sendingRequest) {
  return {
    type: IS_SENDING_USER_REQUEST,
    data: sendingRequest
  };
}

export function setUserRequestError(exception) {
  let error = parseError(exception);

  if (error.phone_number) {
    error["Phone Number"] = error.phone_number;
    delete error["phone_number"];
  }

  return {
    type: SET_USER_REQUEST_ERROR,
    data: error
  };
}

export function clearUserRequestError() {
  return {
    type: CLEAR_USER_REQUEST_ERROR
  };
}

export function setUserRequestSuccess(response) {
  return {
    type: SET_USER_REQUEST_SUCCESS,
    data: response.detail || response
  };
}

export function clearUserRequestSuccess() {
  return {
    type: CLEAR_USER_REQUEST_SUCCESS
  };
}

export function setSelfUser(selfUser) {
  return {
    type: SET_SELF_USER,
    data: selfUser
  };
}

export function setCompleteRegistrationStep(step) {
  return {
    type: SET_COMPLETE_REGISTRATION_STEP,
    data: step
  };
}

export function setCompleteRegistrationClientOrProvider(clientOrProvider) {
  return {
    type: SET_COMPLETE_REGISTRATION_CLIENT_OR_PROVIDER,
    data: clientOrProvider
  };
}

export function setFormPhoneNumber(phoneNumber) {
  return {
    type: SET_FORM_PHONE_NUMBER,
    data: phoneNumber
  };
}

export function setFormBusinessNumber(businessNumber) {
  return {
    type: SET_FORM_BUSINESS_NUMBER,
    data: businessNumber
  };
}

export function setFormSocialInsuranceNumber(socialInsuranceNumber) {
  return {
    type: SET_FORM_SOCIAL_INSURANCE_NUMBER,
    data: socialInsuranceNumber
  };
}

export function setEditProfileTabActiveIndex(indexVal) {
  return {
    type: SET_EDIT_PROFILE_TAB_ACTIVE_INDEX,
    data: indexVal
  };
}

export function setClearUserState() {
  return {
    type: SET_CLEAR_USER_STATE
  };
}
