import React, { Component } from "react";
import { connect } from "react-redux";

import {
  clearUserRequestError,
  clearUserRequestSuccess,
  setFormBusinessNumber
} from "../../actions/user/reducer.actions";
import { createClientRequest } from "../../actions/user/saga.actions";
import ClientFormView from "./ClientFormView";

class InitializeClientForm extends Component {
  componentWillMount() {
    this.props.dispatch(clearUserRequestError());
    this.props.dispatch(clearUserRequestSuccess());
  }

  changeBusinessNumber = event => {
    this.props.dispatch(setFormBusinessNumber(event.target.value));
  }

  onSubmitClient = event => {
    event.preventDefault();
    const { businessNumber } = this.props;
    this.props.dispatch(
      createClientRequest({ business_number: businessNumber })
    );
  };

  render() {
    const {
      isSendingUserRequest,
      userRequestError,
      userRequestSuccess,
      businessNumber
    } = this.props;
    return (
      <ClientFormView
        isSendingUserRequest={isSendingUserRequest}
        userRequestError={userRequestError}
        userRequestSuccess={userRequestSuccess}
        businessNumber={businessNumber}
        changeBusinessNumber={this.changeBusinessNumber}
        onSubmitClient={this.onSubmitClient}
      />
    );
  }
}

function mapStateToProps(state) {
  return { ...state.user };
}

export default connect(mapStateToProps)(InitializeClientForm);
