export const getEmployerFromPrice = (priceUUID, selfUser) => {
  const employers =
    selfUser && selfUser.provider && selfUser.provider.employers;
  let matchEmployer = null;
  employers.forEach(employer => {
    const priceMatch = employer.prices.filter(price => {
      return price.uuid === priceUUID;
    });
    if (priceMatch.length > 0) {
      matchEmployer = employer;
    }
  });
  return matchEmployer;
};

export const getWorkTypeFromPrice = (priceUUID, selfUser) => {
  const employers =
    selfUser && selfUser.provider && selfUser.provider.employers;
  let matchWorkType = null;
  employers.forEach(employer => {
    employer.prices.forEach(price => {
      if (price.uuid === priceUUID) {
        matchWorkType = price.work_type;
      }
    });
  });
  return matchWorkType;
};

export const getPriceFromPrice = (priceUUID, selfUser) => {
  const employers =
    selfUser && selfUser.provider && selfUser.provider.employers;
  let matchPrice = null;
  employers.forEach(employer => {
    employer.prices.forEach(price => {
      if (price.uuid === priceUUID) {
        matchPrice = price;
      }
    });
  });
  return matchPrice;
};
