import {
  IS_SENDING_EMPLOYEE_REQUEST,
  SET_EMPLOYEE_REQUEST_ERROR,
  CLEAR_EMPLOYEE_REQUEST_ERROR,
  SET_EMPLOYEE_REQUEST_SUCCESS,
  CLEAR_EMPLOYEE_REQUEST_SUCCESS,
  SET_EMPLOYEE_UUID,
  SET_FORM_EMPLOYEE_EMAIL,
  SET_FORM_EMPLOYEE_NOTE,
  SET_CLEAR_EMPLOYEE_STATE
} from "../constants/employee.constants";

const initialState = {
  isSendingEmployeeRequest: false,
  employeeRequestError: "",
  employeeRequestSuccess: "",
  uuid: "",
  email: "",
  note: ""
};

function employeeReducer(state = initialState, action) {
  switch (action.type) {
    case IS_SENDING_EMPLOYEE_REQUEST:
      return {
        ...state,
        isSendingEmployeeRequest: action.data
      };
    case SET_EMPLOYEE_REQUEST_ERROR:
      return {
        ...state,
        employeeRequestError: action.data
      };
    case CLEAR_EMPLOYEE_REQUEST_ERROR:
      return {
        ...state,
        employeeRequestError: ""
      };
    case SET_EMPLOYEE_REQUEST_SUCCESS:
      return {
        ...state,
        employeeRequestSuccess: action.data
      };
    case CLEAR_EMPLOYEE_REQUEST_SUCCESS:
      return {
        ...state,
        employeeRequestSuccess: ""
      };
    case SET_EMPLOYEE_UUID:
      return {
        ...state,
        uuid: action.data
      };
    case SET_FORM_EMPLOYEE_EMAIL:
      return {
        ...state,
        email: action.data
      };
    case SET_FORM_EMPLOYEE_NOTE:
      return {
        ...state,
        note: action.data
      };
    case SET_CLEAR_EMPLOYEE_STATE:
      return {
        ...initialState
      };
    default:
      return state;
  }
}

export default employeeReducer;
