import {
  IS_SENDING_PSHIFT_REQUEST,
  SET_PSHIFT_REQUEST_ERROR,
  SET_PSHIFT_REQUEST_SUCCESS,
  CLEAR_PSHIFT_REQUEST_ERROR,
  CLEAR_PSHIFT_REQUEST_SUCCESS,
  SET_FORM_SHIFT_CHART,
  SET_PSHIFT_PAGE,
  SET_PSHIFT_APPROVAL_FILTER,
  SET_PSHIFT_COMPLETED_FILTER,
  SET_PSHIFT_CLIENT_FILTER,
  SET_PSHIFT_WORKTYPE_FILTER,
  SET_CLEAR_PSHIFT_STATE
} from "../constants/pShift.constants";

const initialState = {
  isSendingPShiftRequest: false,
  pShiftRequestError: "",
  pShiftRequestSuccess: "",
  chart: "",
  page: 1,
  approvalFilter: null,
  completedFilter: null,
  clientFilter: null,
  workTypeFilter: null
};

function pShiftReducer(state = initialState, action) {
  switch (action.type) {
    case IS_SENDING_PSHIFT_REQUEST:
      return {
        ...state,
        isSendingPShiftRequest: action.data
      };
    case SET_PSHIFT_REQUEST_ERROR:
      return {
        ...state,
        pShiftRequestError: action.data
      };
    case CLEAR_PSHIFT_REQUEST_ERROR:
      return {
        ...state,
        pShiftRequestError: ""
      };
    case SET_PSHIFT_REQUEST_SUCCESS:
      return {
        ...state,
        pShiftRequestSuccess: action.data
      };
    case CLEAR_PSHIFT_REQUEST_SUCCESS:
      return {
        ...state,
        pShiftRequestSuccess: ""
      };
    case SET_FORM_SHIFT_CHART:
      return {
        ...state,
        chart: action.data
      };
    case SET_PSHIFT_PAGE:
      return {
        ...state,
        page: action.data
      };
    case SET_PSHIFT_APPROVAL_FILTER:
      return {
        ...state,
        approvalFilter: action.data
      };
    case SET_PSHIFT_COMPLETED_FILTER:
      return {
        ...state,
        completedFilter: action.data
      };
    case SET_PSHIFT_CLIENT_FILTER:
      return {
        ...state,
        clientFilter: action.data
      };
    case SET_PSHIFT_WORKTYPE_FILTER:
      return {
        ...state,
        workTypeFilter: action.data
      };
    case SET_CLEAR_PSHIFT_STATE:
      return {
        ...initialState,
        page: state.page,
        approvalFilter: state.approvalFilter,
        completedFilter: state.completedFilter,
        clientFilter: state.clientFilter,
        workTypeFilter: state.workTypeFilter
      };
    default:
      return { ...state };
  }
}

export default pShiftReducer;
