import {
  IS_SENDING_WORKTYPE_REQUEST,
  SET_WORKTYPE_REQUEST_ERROR,
  CLEAR_WORKTYPE_REQUEST_ERROR,
  SET_WORKTYPE_REQUEST_SUCCESS,
  CLEAR_WORKTYPE_REQUEST_SUCCESS,
  SET_WORKTYPE_UUID,
  SET_FORM_WORKTYPE_COLOR,
  SET_FORM_WORKTYPE_LABEL,
  SET_CLEAR_WORKTYPE_STATE
} from "../constants/worktype.constants";

const initialState = {
  isSendingWorktypeRequest: false,
  worktypeRequestError: "",
  worktypeRequestSuccess: "",
  uuid: "",
  color: "",
  label: ""
};

function worktypeReducer(state = initialState, action) {
  switch (action.type) {
    case IS_SENDING_WORKTYPE_REQUEST:
      return {
        ...state,
        isSendingWorktypeRequest: action.data
      };
    case SET_WORKTYPE_REQUEST_ERROR:
      return {
        ...state,
        worktypeRequestError: action.data
      };
    case CLEAR_WORKTYPE_REQUEST_ERROR:
      return {
        ...state,
        worktypeRequestError: ""
      };
    case SET_WORKTYPE_REQUEST_SUCCESS:
      return {
        ...state,
        worktypeRequestSuccess: action.data
      };
    case CLEAR_WORKTYPE_REQUEST_SUCCESS:
      return {
        ...state,
        worktypeRequestSuccess: ""
      };
    case SET_WORKTYPE_UUID:
      return {
        ...state,
        uuid: action.data
      };
    case SET_FORM_WORKTYPE_COLOR:
      return {
        ...state,
        color: action.data
      };
    case SET_FORM_WORKTYPE_LABEL:
      return {
        ...state,
        label: action.data
      };
    case SET_CLEAR_WORKTYPE_STATE:
      return {
        ...initialState
      };
    default:
      return state;
  }
}

export default worktypeReducer;
